{$APPTYPE CONSOLE}

const 
  eps = 1E-10;

var
  fin, fout, fans: Text;
  x, y, xc, yc, R, xw, yw: Double;
  i, N: Integer;
begin
  Assign(fin, ParamStr(3)); Reset(fin);
  Assign(fout, ParamStr(2)); Reset(fout);
  Assign(fans, ParamStr(1)); Reset(fans);
  Read(fout, x, y);
  if (x = -1) and (y = -1) then begin
    Read(fans, x, y);
    if (x = -1) and (y = -1) then Halt(0) else Halt(1);
  end;
  Read(fin, xw, yw, N, r);

  if (x < 0) or (x > xw) or (y < 0) or (y > yw) then
  begin
    writeln ('All bad');
    Halt(1);
  end; 

  for i := 1 to N do begin
    Read(fin, xc, yc);
    if (Sqr(x - xc) + Sqr(y - yc) < (Sqr(R) - eps)) then 
    begin 
      writeln ('All bad'); 
      writeln ('Participant answer:', x, ' ', y);
      writeln ('Conflicting circle:', xc, ' ', yc, ' ', r);
      writeln ('Distance:', sqrt(Sqr(x - xc) + Sqr(y - yc)));
      Halt(1); 
    end;
  end;
  writeln ('All good');
  Close(fans);
  Close(fout);
  Close(fin);
end.
